#include<iostream>
#include<map>
#include<set>
using namespace std;
map <int, int> bridges[2];
set <int> removed[2];
int n;
bool check_same_side (int x, int y, bool side) {
    if (side==0) {
        if (x>y) return false;
        if ((*removed[0].lower_bound(x))<y) return false;
        return true;
    }
    if (x<y) return false;
    if ((*removed[1].lower_bound(y))<x) return false;
    return true;
}
int go_down (int x, bool flag) {
    map <int, int>::iterator it;
    if (flag==false) it=bridges[0].lower_bound(x);
    else it=--bridges[0].upper_bound(x);
    auto [x1, y1]=*it;
    if ((x<=x1)&&(check_same_side(x,x1,0)==true)) return y1;
    else if ((x>x1)&&(check_same_side(x1,x,0)==true)) return y1;
    return n-2;
}
int go_up (int x, bool flag) {
    map <int, int>::iterator it;
    if (flag==false) it=--bridges[1].upper_bound(x);
    else it=bridges[1].lower_bound(x);
    auto [x1, y1]=*it;
    if ((x>=x1)&&(check_same_side(x,x1,1)==true)) return y1;
    else if ((x<x1)&&(check_same_side(x1,x,1)==true)) return y1;
    return n+1;
}
bool check_different_sides (int x, int y, bool side) {
    //cout << x+1 << " " << y+1 << " " << side << endl ;
    if (side==0) {
        if (x==n+1) return false;
        int y1=go_down(x,false);
        //cout << y1+1 << " " << y+1 << endl ;
        if (check_same_side(y1,y,1)==true) return true;
        int x1=go_up(y,true);
        //cout << x+1 << " " << x1+1 << endl ;
        return check_same_side(x,x1,0);
    }
    if (x==n-2) return false;
    int y1=go_up(x,false);
    //cout << y1+1 << " " << y+1 << endl ;
    if (check_same_side(y1,y,0)==true) return true;
    int x1=go_down(y,true);
    //cout << x+1 << " " << x1+1 << endl ;
    return check_same_side(x,x1,1);
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int m;
    cin >> n >> m ;
    bridges[0][n]=n-2;
    bridges[1][n-1]=n+1;
    removed[0].insert(-1); removed[0].insert(n-1);
    removed[1].insert(n-1); removed[1].insert(2*n-1);
    char type;
    int x,y;
    for (int i=0; i<m; i++) {
        cin >> type >> x >> y ;
        x--; y--;
        if (type=='A') {
            if (x>y) swap(x,y);
            bridges[0][x]=y;
            bridges[1][y]=x;
        }
        else if (type=='B') {
            if (x<n) {
                if (x>y) swap(x,y);
                removed[0].insert(x);
            }
            else {
                if (x<y) swap(x,y);
                removed[1].insert(y);
            }
        }
        else {
            if ((x<n)&&(y<n)) {
                if (x<y) cout << (check_same_side(x,y,0)?"YES\n":"NO\n") ;
                else cout << (check_different_sides(go_down(x,false),y,1)?"YES\n":"NO\n") ;
            }
            else if ((x>=n)&&(y>=n)) {
                if (x>y) cout << (check_same_side(x,y,1)?"YES\n":"NO\n") ;
                else cout << (check_different_sides(go_up(x,false),y,0)?"YES\n":"NO\n") ;
            }
            else if ((x<n)&&(y>=n)) cout << (check_different_sides(x,y,0)?"YES\n":"NO\n") ;
            else cout << (check_different_sides(x,y,1)?"YES\n":"NO\n") ;
        }
    }
    return 0;
}
